//-----------------------------------------------------------------------------
// 1) Download the code to an C8051F020 Development Board
// 2) Ensure that pins 1 and 2 on the J22 header on the development board
//    are shorted together.  This connects VREF to decoupling capacitors.
// 3) Connect two oscillscope probes to pins DAC0 and DAC1.  These pins are 
//    available on both the J11 (pins 3 and 4 respectively) and J20 headers
//    (pin 3 and 4 respectively).
// 4) Confirm that there are two waveforms with the output of DAC1 leading 
//    the output DAC0 by 90 degrees.  The frequency of both waveforms should
//    be close to frequency defined by <FREQUENCY>
//-----------------------------------------------------------------------------
#include <c8051f020.h>
sfr16 RCAP4    = 0xE4;                 // Timer4 capture/reload
sfr16 TMR4     = 0xF4;                 // Timer4
sfr16 DAC0     = 0xd2;                 // DAC0 data
sfr16 DAC1     = 0xd5;                 // DAC1 data
//-----------------------------------------------------------------------------
// Global Constants
//-----------------------------------------------------------------------------
//#define SYSCLK          22118400       // Internal oscillator frequency in Hz
#define SAMPLE_RATE_DAC 100000L        // DAC sampling rate in Hz
#define PHASE_PRECISION 65536          // range of phase accumulator
#define FREQUENCY       1000           // Frequency of output waveform in Hz                                      
// <PHASE_ADD> is the change in phase between DAC samples; It is used in 
// the set_DACs routine.
//-----------------------------------------------------------------------------
// Function Prototypes
//-----------------------------------------------------------------------------

void DAC0_Init(void)
{
   DAC0CN = 0x80;                      // Enable DAC0 in left-justified mode
                                       // managed by Timer4 overflows

 //  REF0CN |= 0x03;                     // Enable the internal VREF (2.4v) and
                                       // the Bias Generator
}
