#include <c8051f020.h>
#include <stdio.h>
#include <math.h>
#include "DataType.h"
#include "lcd.h"

#define		W_CMD		1			//ָ
#define		W_DAT		0			//
#define SetLCDRS  P4 |= 0x08 		 //궨壬LCD_RSλ
#define ClrLCDRS  P4 &= ~0x08
#define SetLCDRST P4 |= 0x80 		 //궨壬LCD_RSTλ
#define ClrLCDRST P4 &= ~0x80

sbit	SCK=P3^4;
sbit	SDA=P3^5;

extern const unsigned char code AsciiFontData[95][16];

static void Delayms(unsigned int ms)
{
	int i;
	while(ms--)
	for(i=0;i<=20;i++);
}

void WrateC(unsigned char com)

{
    unsigned char data i,j,k;
	    ClrLCDRS;  
		for(i=0;i<8;i++)
	    { 
			 j=com;	 			 
			 SDA=com&0x80; 
			 SCK=0;
			 for(k = 0;k < 3;k ++);//ʱ
	         SCK=1;	
			 for(k = 0;k < 3;k ++);//ʱ     
			 com=j<<1;
		}
		SetLCDRS;
}

void WrateD(unsigned char dat)

{
    unsigned char data i,j,k;
	    SetLCDRS;  
		for(i=0;i<8;i++)
	    { 
			 j=dat;
			 
			 SDA=dat&0x80;
			 SCK=0;
			 for(k = 0;k < 3;k ++);//ʱ
	         SCK=1;	  
			 for(k = 0;k < 3;k ++);//ʱ   
			 dat=j<<1;
		}
		ClrLCDRS;
}

void LCDWrite(unsigned char type,unsigned char dat)
{ 

	if(type)
	{
		WrateC(dat);
	}
	else
	{
		WrateD(dat);
	}
}

void LCD_Init()
{
 	P3MDOUT |= BIT(4) + BIT(5); //P3.4 P3.5 LCD IO 
  P74OUT |= BIT0;             //P4.0-P4.4Ϊ
	SetLCDRST;
	Delayms(10);
	ClrLCDRST;
	Delayms(10);
	SetLCDRST;
	Delayms(10);
	LCDWrite(W_CMD,0xE2);	//λ
	LCDWrite(W_CMD,0xA3);//Bais set		ʾƫѹ
	LCDWrite(W_CMD,0xA0);//ADC segѡ 0xa00xA1Ҿ
	LCDWrite(W_CMD,0xC0);//com output scan directioncomѡ 0xc00xC8¾
	LCDWrite(W_CMD,0x26);
	Delayms(5);

	

	LCDWrite(W_CMD,0x2C);//ڲԴ
	Delayms(10);
	LCDWrite(W_CMD,0x2E);//ָʱ2ms
	Delayms(10);
	LCDWrite(W_CMD,0x2F);
	Delayms(10);

//	LCDWrite(W_CMD,0x24);//ѹĴλ Χ0x21-0x27 
	LCDWrite(W_CMD,0x81);//ѹģʽѡ
	LCDWrite(W_CMD,0x20);//ѹĴλ Χ0x00-0x3f
	Delayms(10);
	LCDWrite(W_CMD,0xF8);
	LCDWrite(W_CMD,0x01);
    Delayms(5);
	LCDWrite(W_CMD,0xAF);//ʾ         
//	LCDWrite(W_CMD,0x40);//пʼʾ
}
//---------------------------------------------
//LCD_set_XY: LCD꺯
//X0127  Y07
//дڣ
//---------------------------------------------
void LCD_setXY(unsigned char X, unsigned char Y)
{
	unsigned char gao,di;
	WrateC(0xB0 | Y); //ҳ
	gao = X & 0xf0;
	gao = gao >> 4;
	di = X & 0x0f;
	WrateC(0x10 | gao);  //set Column address MSB
    WrateC(0x00 | di);  //set column address LSB

}

void LCD_Clear()
{
   unsigned char page,j;
	 for(page=0xB7;page>=0xB0;page--)  
    {  
	LCDWrite(W_CMD,page);
	LCDWrite(W_CMD,0x10);
	LCDWrite(W_CMD,0x00);  
     for(j=0;j<128;j++)  
        {  
         WrateD(0x00);  
        }  
    } 
}	  
void ClearLine(char row)
{
   unsigned char pMax,pMin,page,j;
   switch(row)
   {
   case 0:pMax=0xB7;pMin=0xB6;break;
   case 1:pMax=0xB5;pMin=0xB4;break;
   case 2:pMax=0xB3;pMin=0xB2;break;
   case 3:pMax=0xB1;pMin=0xB0;break;
   default:pMax=0xB7;pMin=0xB0;break;
  }
	 for(page=pMax;page>=pMin;page--)  
    {  
	LCDWrite(W_CMD,page);
	LCDWrite(W_CMD,0x10);
	LCDWrite(W_CMD,0x00);  
     for(j=0;j<128;j++)  
        {  
         WrateD(0x00);  
        }  
    } 
}

void LCD_DrawPoint(unsigned char x,unsigned char y)
{
    unsigned char senddat,yy;
	static unsigned char DataOld=0,yOld=0,xOld=0;
	yy=(int)(y/8);
	if((yy==yOld)&&(x==xOld))
	   senddat = DataOld | (0x80>>(y%8));
	else
	   senddat = 0x80>>(y%8);
	LCD_setXY(x,abs(yy-7));
	LCDWrite(W_DAT,senddat);
	DataOld = senddat;
	yOld=yy;
	xOld=x;
}


/*********************************************************************
*Ļʾһַ
*Cַ  	row :0~3  col :0~15
*********************************************************************/
void LCD_Drawchar(unsigned char C,unsigned char row,unsigned char col)
{	
    unsigned char b,Row,Col;
    unsigned char k;
	k=C-0x20;
	Row=(63-(16*row));
	Col=8*col;

	for(b = 0;b<16;b++)
	{
	  unsigned char F;
	  F=2*b;
	 if(b<8)
	 {
	  if((AsciiFontData[k][b]&0x80)!=0)
	  LCD_DrawPoint(Col+b,Row);
	  	
	  
	  if((AsciiFontData[k][b]&0x40)!=0)
	  LCD_DrawPoint(Col+b,Row-1);
	   	
	  if((AsciiFontData[k][b]&0x20)!=0)
	  LCD_DrawPoint(Col+b,Row-2);
	   	
	  if((AsciiFontData[k][b]&0x10)!=0)
	  LCD_DrawPoint(Col+b,Row-3);

	  if((AsciiFontData[k][b]&0x08)!=0)
	  LCD_DrawPoint(Col+b,Row-4);
	  	
	  if((AsciiFontData[k][b]&0x04)!=0)
	  LCD_DrawPoint(Col+b,Row-5);
	   
	  if((AsciiFontData[k][b]&0x02)!=0)
    LCD_DrawPoint(Col+b,Row-6);
	  	
	  if((AsciiFontData[k][b]&0x01)!=0)
	  LCD_DrawPoint(Col+b,Row-7);
	  }
	  else
	  {
	  if((AsciiFontData[k][b]&0x80)!=0)
	  LCD_DrawPoint(Col+b-8,Row-8);
	  	
	  
	  if((AsciiFontData[k][b]&0x40)!=0)
	  LCD_DrawPoint(Col+b-8,Row-9);
	   	
	  if((AsciiFontData[k][b]&0x20)!=0)
	  LCD_DrawPoint(Col+b-8,Row-10);
	   	
	  if((AsciiFontData[k][b]&0x10)!=0)
	  LCD_DrawPoint(Col+b-8,Row-11);

	  if((AsciiFontData[k][b]&0x08)!=0)
	  LCD_DrawPoint(Col+b-8,Row-12);
	  	
	  if((AsciiFontData[k][b]&0x04)!=0)
	  LCD_DrawPoint(Col+b-8,Row-13);
	   
	  if((AsciiFontData[k][b]&0x02)!=0)
    LCD_DrawPoint(Col+b-8,Row-14);
	  	
	  if((AsciiFontData[k][b]&0x01)!=0)
	  LCD_DrawPoint(Col+b-8,Row-15);
	  }	  
	
	}
}

/*********************************************************************
*Ļʾһַ
*Cַ  	row ʼ:0~3  low ʼ:0~15
*********************************************************************/
void LCD_DrawcharS(unsigned char *C,unsigned char row,unsigned char col)
{
  int flag=0,i=0;
  unsigned char R,L,TOTAL;
  TOTAL=(row*16)+col;
  if(TOTAL>63||row>3||col>15)
   {flag=1;}

  while(flag==0)
  {
   if(*C!='\0')
   {
     R=	(TOTAL+i)/16 ;
   	 L=	(TOTAL+i)%16;
	 LCD_Drawchar(*C,R,L);
	 C++;
	 i++;
	 if((TOTAL+i)>63)
	  {
	   	 flag=1;
	  }
   }
   else
   {
     flag=1;
   }
 }
}
					
