#include "C8051F020.h"
#include "DataType.h"
#include "string.h"
#include "stdio.h"
//-------------------------------------------------------------------------
#define	W_CMD    0xf8  //д
#define	W_DAT    0xfa  //д
//-------------------------------------------------------------------------
sbit RET = P3^6;       //λź
sbit DAT = P3^5;       //ź
sbit CLK = P3^4;       //ʱź
//-------------------------------------------------------------------------

/**************************************************************************
ƣLCD_WriteData()
ܣLCDӿSPI߷ݡ
ڲtype		͵
          dat		͵		  
ڲ
***************************************************************************/
void  LCD_WriteData (INT8U type, INT8U dat)
{
    INT8U i;
    INT16U j;
    INT32U d, s_dat;//һη͵24λ
    d = type;// дָf8faָfcfe
    d <<= 8;
    d |= dat & 0xf0;
    d <<= 8;
    d |= (dat & 0x0f) << 4;	//24λ
    for(i = 0; i < 24; i ++)
    {
        s_dat = (d & 0x800000);
        if(s_dat == 0x800000)
        //LCDSID=1;//P3.3Ϊ
            DAT = 1;
        else
        //LCDSID=0;
            DAT = 0;
        //LCDCLK=0;//ʱλ͵ƽ
        CLK = 0;
        for(j = 0; j < 10; j ++);//ʱ
        //LCDCLK=1;//ʱλߵƽ
        CLK = 1;
        d <<= 1; //һλ					 
    }
    //LCDCLK=0;//CLK
    CLK = 0;
    //LCDSID=0;//λSID
    DAT = 0;
}
void LCD_Reset ()
{
    INT8U i;
    RET = 0;
    for(i = 1; i < 50; i++);
    RET = 1;
}
/**************************************************************************
*:LCD_Init()
*:ʼLCD
*˵:
*
***************************************************************************/
void LCD_Init ()
{
    INT16U i;
    P3MDOUT |= BIT(4) + BIT(5) + BIT(6); //P3.4 P3.5 P3.6 LCD IO 
    RET = 1;                             //ֹλ
    LCD_Reset ();                        //λLCD
    LCD_WriteData (W_CMD, 0x01);       	 //ʾ 
    LCD_WriteData (W_CMD, 0x30);       	 //趨8λݣָ 
    LCD_WriteData (W_CMD, 0x02);       	 //ַλAC=00hα귵ԭ
    LCD_WriteData (W_CMD, 0x04);      	 //ƶã治ƣƣAC++
    LCD_WriteData (W_CMD, 0x0C);       	 //ʾ״̬LCDأ׹
    LCD_WriteData (W_CMD, 0x01);       	 //ʾʾĻ
    for(i = 1; i < 50; i++);             // Set LCD frame freq = ACLK/128
}
/****************************end Init_LCD*********************************/



/**************************************************************************
*:LCD_ClearScreen()
*:LCDMEMе
*˵:
*
**************************************************************************/
void LCD_ClearScreen()
{                                       
    LCD_WriteData (W_CMD, 0X01);//LCD
}
/*************************end Clear_LCD***********************************/
void LCD_SetDisAdd(INT8U row, INT8U col)
{
    INT8U add;
    switch(row)	//AC
    {
        case 1:add = 0x80;break;
        case 2:add = 0x90;break;
        case 3:add = 0x88;break;
        case 4:add = 0x98;break;
        default:add = 0x99;break;
    }
    add |= (col - 0x01);
    LCD_WriteData (W_CMD, add);	//AC   
}

/*************************************************************************
* ƣLCD_DispStr
* ܣڵǰλʾַ
**************************************************************************/
void LCD_DispStr (INT8S s[])
{
    INT8U i;
    LCD_WriteData (W_CMD, 0x30);   //лģʽ
    for(i = 0; s[i] != '\0'; i++)	//д
    {
        LCD_WriteData (W_DAT, s[i]);
    }	
}

/**************************************************************************
* ƣLCD_DispChar
* ܣǰλʾַ
***************************************************************************/
 void LCD_DispChar (INT8S c)
{
    LCD_WriteData (W_CMD, 0x30);
    LCD_WriteData (W_DAT, c);
}

/**************************************************************************
ƣvoid LCD_DrawEnable(uint8 enable)
ܣlcdͼл
ڲenable   0---ͼܹ          1---ͼܿ
ڲ
***************************************************************************/
void LCD_DrawEnable(INT8U enable)
{
    INT16U i;
    if(enable == 0)
    { 
        LCD_WriteData (W_CMD, 0x34); //չܣͼܹ
        for(i = 1; i < 50; i++);
    }
    else
    {
        LCD_WriteData (W_CMD, 0x36);  //չܣͼܿ
        for(i = 1; i < 50; i++);
    }		
} 

/**************************************************************************
LCD_ClearPoint ()
  ܣͼʾ
***************************************************************************/
void  LCD_ClearPoint ()
{
    INT8U i, j;
    LCD_DrawEnable (0);
    for(i = 0; i < 32; i++)
    {
        for(j = 0; j < 16; j++)
        {
            LCD_WriteData (W_CMD, 0x80 + i);
            LCD_WriteData (W_CMD, 0x80 + j);
            LCD_WriteData (W_DAT, 0x00);
            LCD_WriteData (W_DAT, 0x00);   
        }
    }     
    LCD_DrawEnable(1);  
}

/**************************************************************************
LCD_DrawPoint()
  ܣĻһ
***************************************************************************/

void LCD_DrawPoint(INT8U x, INT8U y)    
{
    INT8U board;
    INT8U x1, x2;
    INT8U y1, roar, div, left;
    if(y < 33)
    {
        roar = 0;
        y1 = y - 1;
    }
    else
    {
        roar = 1;
        y1 = y - 33;
    }   
    div = (x - 1) / 16 ;  
    board = div + roar * 8;
    left = x % 16 ;
    switch (left)
    {
    case 0:
	{
        x1 = 0x00;
	    x2 = 0x01;
	    break;
	}	
    case 1:
	{
        x1 = 0x80;
	    x2 = 0x00;
	    break;
	}
    case 2:
	{
        x1 = 0x40;
	    x2 = 0x00;
	    break;
	}
    case 3:
	{
        x1 = 0x20;
	    x2 = 0x00;
	    break;
	}
    case 4:
	{
        x1 = 0x10;
	    x2 = 0x00;
	    break;
	}
    case 5:
	{
        x1 = 0x08;
	    x2 = 0x00;
	    break;
	}
    case 6:
	{
        x1 = 0x04;
	    x2 = 0x00;
	    break;
	}
    case 7:
	{
        x1 = 0x02;
	    x2 = 0x00;
	    break;
	}
    case 8:
	{
        x1 = 0x01;
	    x2 = 0x00;
	    break;
	}
    case 9:
	{
        x1 = 0x00;
	    x2 = 0x80;
	    break;
	}
    case 10:
	{
        x1 = 0x00;
	    x2 = 0x40;
	    break;
	}
    case 11:
	{
        x1 = 0x00;
        x2 = 0x20;
	    break;
	}
    case 12:
	{
        x1 = 0x00;
	    x2 = 0x10;
	    break;
	}
    case 13:
	{
        x1 = 0x00;
	    x2 = 0x08;
	    break;
	}
    case 14:
	{
        x1 = 0x00;
	    x2 = 0x04;
	    break;
	}
    case 15:
	{
        x1 = 0x00;
	    x2 = 0x02;
	    break;
	}
    default:
	    x1 = 0x00;
	    break;
    } 
    LCD_DrawEnable (0);    //رջͼ
    LCD_WriteData (W_CMD, 0x80 + y1);
    LCD_WriteData (W_CMD, 0x80 + board);
    LCD_WriteData (W_DAT, x1);
    LCD_WriteData (W_DAT, x2);  
    LCD_DrawEnable (1);    //
}

/*************************************************************************
: LCD_DispStrAt
: ʾַ
: row: ʾַ(1пʼ)
          col: ʾַ(1пʼһռ2)
          str: Ҫʾַ
**************************************************************************/
void LCD_DispStrAt(INT8S str[], INT8U row, INT8U col)   //lcdʾַ 
{
	if (str == 0)
	{
		return;
	}
    LCD_SetDisAdd (row, col);
    LCD_DispStr (str);
}

void LCD_DispNumberAt(INT16U NO, INT8U row, INT8U col)
{
    unsigned int a;  
    INT8U  m[5];
	INT8U idata rr[25] = {0};
    INT8U i = 0, j;
	 
    a = NO;

    while(a)
	{
    	m[i++] = a%10 + 48;
    	a = a/10;
    }

    for(j = 0; j < i; j++)
    {
      	rr[j] = m[i - j - 1];
    }

	LCD_DispStrAt(rr, row, col);   //lcdʾַ
        
}

void LCD_DispFloatNumberAt (float NO, INT8U l, INT8U row, INT8U col)
//lʾʾСλ
{
    INT8U str[25] = {0}, f[5] = "%.", temp[3];

	temp[0] = l + 0x30;
	temp[1] = 'f';
	temp[2] = '\0';
	strcat (f, temp); // n = 2ʱfбֵΪ"%.2f"ʾԸʽ2λСλ

	sprintf  (str, f, NO);	// datʽַ

	if (strlen (str) > 16)
	{
		str [16] = '\0';
	}

	LCD_DispStrAt(str, row, col);   //lcdʾַ    
}



